﻿using Prism.Ioc;
using Prism.Modularity;
using System.Linq;
using System.Reflection;
using System.Text.RegularExpressions;

namespace $safeprojectname$ {
  public class PluginModule : IModule {
    public void OnInitialized(IContainerProvider containerProvider) {
    }

    public void RegisterTypes(IContainerRegistry containerRegistry) {
      var pattern = new Regex($"{GetType().Namespace}(\\..+)*\\.Views(\\..*)?", RegexOptions.Compiled);
      foreach (var t in this.GetType().GetTypeInfo().Assembly
          .DefinedTypes
          .Where(t => t.Namespace != null)
          .Where(t => pattern.IsMatch(t.Namespace))) {
        containerRegistry.RegisterForNavigation(t.AsType(), t.FullName);
      }
    }

  }
}